// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;


public class Instructions extends Panel {
    
    private static final Color bgcolor = new Color(255,255,250);
    //private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;
    public Button bupdate;
    
    Trans_State state;
  
    public Instructions(Trans_State state){
	super();
        this.state = state;
	setLayout(null);
	setBackground(bgcolor);
        
        // update button
	bupdate = new Button("CLOSE");
        bupdate.setBackground(new Color(240,240,255));
	add(bupdate);
        int buttonx = 550;
        int buttony = 350;
        int buttonwide = 70;
        int buttonheight = 27;
        
        bupdate.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
	    add(ps7);
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    add(ps8);
	    ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);
	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        //boolean saveOldFlag = MaestroG.useBiggerFont;
        //MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        g.drawRect(0,0,getSize().width-1,getSize().height-1);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));
        g.drawString("Instructions", 20,25);
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));
        g.drawString("Inputs", 25,50);
        int startx2 = 400;
        g.drawString("Displayed Information", startx2,50);
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        int deltaY = 20; int starty = 80;
        //INPUT
        g.setFont(new Font("SanSerif",Font.BOLD,14));
        g.drawString("Set: Load", 25,starty);
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        g.drawString("Load Parameters", 25,starty+deltaY);
        g.drawString("Design Target for SWR", 25,starty+2*deltaY);
        
        g.setFont(new Font("SanSerif",Font.BOLD,14));
        g.drawString("Set: Line / Transformer", 25,starty+3*deltaY);
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        g.drawString("Characteristic impedance of line", 25,starty+4*deltaY);
        MaestroG.subscripter("\u03b5","r"," = relative permittivity of dielectric",
                             g,14,25,starty+5*deltaY);
        g.drawString("Location of \u03bb/4 Transformer", 25,starty+6*deltaY);
        g.drawString("Characteristic impedance of \u03bb/4 Transformer", 25,starty+7*deltaY);
        
        g.setFont(new Font("SanSerif",Font.BOLD,14));
        g.drawString("Set: Frequency", 25,starty+8*deltaY);
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        MaestroG.subscripter("f","o"," = design frequency",
                             g,14,25,starty+9*deltaY);
        
        g.setFont(new Font("SanSerif",Font.BOLD,14));
        g.drawString("Set: Generator", 25,starty+10*deltaY);
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        g.drawString("Voltage and source impedance of generator", 25,starty+11*deltaY);
        
        //OUTPUT
        
        g.drawString("SWR = Standing Wave Ratio",startx2,starty);
        g.drawString("| \u0393 | = magnitude of reflection coefficient",
                     startx2,starty+deltaY);
        
        starty +=10;
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        g.drawString("Impedance matching condition can be realized by",startx2,starty+2*deltaY);
        g.drawString("changing transformer location and impedance.  The",startx2,starty+3*deltaY);
        g.drawString("user can monitor the Smith chart or the standing",startx2,starty+4*deltaY);
        g.drawString("wave pattern plots to ensure that correct trends",startx2,starty+5*deltaY);
        g.drawString("are followed during the procedure.",startx2,starty+6*deltaY);
        starty +=10;
        g.setFont(new Font("SanSerif",Font.BOLD,14));
        g.drawString("An alert is displayed on the Circuit Diagram",startx2,starty+7*deltaY);
        g.drawString("when the design target for SWR is achieved.",startx2,starty+8*deltaY);
        
        drawCopyRight(g);
        //MaestroG.useBiggerFont = saveOldFlag;

    }


    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 70;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();
        g.drawString("Applet Design: Umberto Ravaioli",
                     startingX+15,startingY+deltaY);
        
        MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
                               g,14,startingX+15,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength += 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        g.drawString("All Rights Reserved",startingX+15,startingY+3*deltaY);
        g.drawLine(startingX,startingY,
                   startingX+lineLength+25,startingY);
        g.drawLine(startingX+lineLength+25,startingY,
                   startingX+lineLength+25,startingY+4*deltaY);
    }


//----------------------------------------------------------------------------------------    
}//End
    

